// From the software distribution accompanying the textbook
// "A Practical Introduction to Data Structures and Algorithm Analysis,
// Third Edition" by Clifford A. Shaffer, Prentice Hall, 2007.
// Source code Copyright (C) 2006 by Clifford A. Shaffer.

// Heapsort implementation and timing test driver
// This heapsort uses a modified siftdown operation that
// always promotes the larger child regardless of root value.

#include <iostream>
using namespace std;

#include "book.h"

// Include comparator functions
#include "compare.h"

// Implementation of heap with modified siftdown operation
#include "maxheap2.ht"

// Heapsort implementation
template <class Elem, class Comp>
void heapsort(Elem A[], int n) { // Heapsort
  Elem maxval;
  maxheap<Elem,Comp> H(A, n, n); // Build the heap
  for (int i=0; i<n; i++)        // Now sort
    H.removemax(maxval); // Removemax places maxval at end
}


template <class Elem, class Comp>
void sort(Elem* array, int n) {
 heapsort<Elem,Comp>(array, n);
}

#include "sortmain.cpp"
