// From the software distribution accompanying the textbook
// "A Practical Introduction to Data Structures and Algorithm Analysis,
// Third Edition" by Clifford A. Shaffer, Prentice Hall, 2007.
// Source code Copyright (C) 2006 by Clifford A. Shaffer.

// Insertion Sort implementation and timing test driver

#include <iostream>
using namespace std;

#include "book.h"

// Include comparator functions
#include "compare.h"

// Insertion sort implementation
template <class Elem, class Comp>
void inssort(Elem A[], int n) { // Insertion Sort
  for (int i=1; i<n; i++)       // Insert i'th record
    for (int j=i; (j>0) && (Comp::lt(A[j], A[j-1])); j--)
      swap(A, j, j-1);
}

template <class Elem, class Comp>
void sort(Elem* array, int n) {
  inssort<Elem,Comp>(array, n);
}

#include "sortmain.cpp"
