// Linked stack implementation
template <class Elem> class LStack: public Stack<Elem> {
private:
  Link<Elem>* top;            // Pointer to first element
  int size;                   // Number of elements

public:
  LStack(int sz =DefaultListSize) { top = NULL; size = 0; }
  ~LStack() { clear(); }      // Destructor

  void clear() {              // Reinitialize
    while (top != NULL) {     // Delete link nodes
      Link<Elem>* temp = top;
      top = top->next;
      size = 0;
      delete temp;
    }
  }

  bool push(const Elem& it) { // Put it on stack
    top = new Link<Elem>(it, top);
    size++;
    return true;
  }

  bool pop(Elem& it) {        // Remove it from stack
    if (size == 0) return false;
    it = top->element;
    Link<Elem>* ltemp = top->next;
    delete top;
    top = ltemp;
    size--;
    return true;
  }

  bool topValue(Elem& it) const { // Return top value
    if (size == 0) return false;
    it = top->element;
    return true;
  }

  int length() const { return size; } // Return length
};
