// From the software distribution accompanying the textbook
// "A Practical Introduction to Data Structures and Algorithm Analysis,
// Third Edition" by Clifford A. Shaffer, Prentice Hall, 2007.
// Source code Copyright (C) 2006 by Clifford A. Shaffer.

// Selection Sort implementation and timing test driver

#include <iostream>
using namespace std;

#include "book.h"

// Include comparator functions
#include "compare.h"

// Selection sort implementation
template <class Elem, class Comp>
void selsort(Elem A[], int n) { // Selection Sort
  for (int i=0; i<n-1; i++) {   // Select i'th record
    int lowindex = i;           // Remember its index
    for (int j=n-1; j>i; j--)   // Find the least value
      if (Comp::lt(A[j], A[lowindex]))
	lowindex = j;           // Put it in place
    swap(A, i, lowindex);
  }
}

template <class Elem, class Comp>
void sort(Elem* array, int n) {
  selsort<Elem,Comp>(array, n);
}

#include "sortmain.cpp"
